<!DOCTYPE html>
<html lang="en">

<head>
    <title>Users - Dokumenta</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <link rel="icon" type="image/ico" href="{{ url_for('static', filename='favicon.ico') }}">

    <link rel="stylesheet" href="{{ url_for('static', filename='vendors/mdi/css/materialdesignicons.min.css') }}">
    <link rel="stylesheet" href="{{ url_for('static', filename='css/style.css') }}">
    <script src="{{ url_for('static', filename='js/redirection.js') }}"></script>
</head>

<body>
    <div class="container-scroller">
        <nav class="sidebar sidebar-offcanvas" id="sidebar">
            <div class="sidebar-brand-wrapper d-none d-lg-flex align-items-center justify-content-center fixed-top">
                <a class="sidebar-brand brand-logo" href="/"><img src="{{ url_for('static', filename='images/logo.svg') }}" alt="Logo"></a>
                <a class="sidebar-brand brand-logo-mini" href="/"><img src="{{ url_for('static', filename='images/logo-mini.svg') }}" alt="Logo Mini"></a>
            </div>
            <ul class="nav">
                <li class="nav-item nav-category">
                    <span class="nav-link">Navigation</span>
                </li>
                <li class="nav-item menu-items">
                    <a class="nav-link" href="/">
                        <span class="menu-icon">
                            <i class="mdi mdi-speedometer"></i>
                        </span>
                        <span class="menu-title">Dashboard</span>
                    </a>
                </li>
                <li class="nav-item menu-items">
                    <a class="nav-link" href="/categories">
                        <span class="menu-icon">
                            <i class="mdi mdi-table-large"></i>
                        </span>
                        <span class="menu-title">Categories</span>
                    </a>
                </li>
                <li class="nav-item menu-items">
                    <a class="nav-link" href="/documents">
                        <span class="menu-icon">
                            <i class="mdi mdi-table-large"></i>
                        </span>
                        <span class="menu-title">Documents</span>
                    </a>
                </li>
                <li class="nav-item menu-items">
                    <a class="nav-link" href="/users">
                        <span class="menu-icon">
                            <i class="mdi mdi-table-large"></i>
                        </span>
                        <span class="menu-title">Users</span>
                    </a>
                </li>
                <li class="nav-item menu-items">
                    <a class="nav-link" href="/docs/v1" target="_blank">
                        <span class="menu-icon">
                            <i class="mdi mdi-file-document-box"></i>
                        </span>
                        <span class="menu-title">API Documentation</span>
                    </a>
                </li>
            </ul>
        </nav>
        <div class="container-fluid page-body-wrapper">
            <nav class="navbar p-0 fixed-top d-flex flex-row">
                <div class="navbar-brand-wrapper d-flex d-lg-none align-items-center justify-content-center">
                    <a class="navbar-brand brand-logo-mini" href="/"><img src="{{ url_for('static', filename='images/logo-mini.svg') }}" alt="Logo Mini"></a>
                </div>
                <div class="navbar-menu-wrapper flex-grow d-flex align-items-stretch">
                    <button class="navbar-toggler navbar-toggler align-self-center" type="button" data-toggle="minimize">
                        <span class="mdi mdi-menu"></span>
                    </button>
                    <ul class="navbar-nav w-100"></ul>
                    <ul class="navbar-nav navbar-nav-right">
                        <li class="nav-item dropdown">
                            <a class="nav-link" id="profileDropdown" href="#" data-toggle="dropdown">
                                <div class="navbar-profile">
                                    <p class="mb-0 d-none d-sm-block navbar-profile-name" id="usernameTopRight">USERNAME</p>
                                    <i class="mdi mdi-menu-down d-none d-sm-block"></i>
                                </div>
                            </a>
                            <div class="dropdown-menu dropdown-menu-right navbar-dropdown preview-list" aria-labelledby="profileDropdown">
                                <a class="dropdown-item preview-item" id="logoutButton">
                                    <div class="preview-thumbnail">
                                        <div class="preview-icon bg-dark rounded-circle">
                                            <i class="mdi mdi-logout text-danger"></i>
                                        </div>
                                    </div>
                                    <div class="preview-item-content">
                                        <p class="preview-subject mb-1">Logout</p>
                                    </div>
                                </a>
                            </div>
                        </li>
                    </ul>
                    <button class="navbar-toggler navbar-toggler-right d-lg-none align-self-center" type="button" data-toggle="offcanvas">
                        <span class="mdi mdi-format-line-spacing"></span>
                    </button>
                </div>
            </nav>

            <div class="main-panel">
                <div class="content-wrapper">
                    <div class="row">
                        <div class="col-lg-12 grid-margin stretch-card">
                            <div class="card">
                                <div class="card-body">
                                    <h4 class="card-title">Users</h4>

                                    <button type="button" class="btn btn-primary p-1 px-2" data-toggle="modal" data-target="#createModal">
                                        <i class="mdi mdi-plus mdi-18px m-0"></i>
                                    </button>

                                    <div class="table-responsive">
                                        <table class="table table-striped" id="table">
                                            <thead>
                                                <tr>
                                                    <th style="width: 150px;">#</th>
                                                    <th>Username</th>
                                                    <th>Role</th>
                                                    <th class="fit">Action</th>
                                                </tr>
                                            </thead>
                                            <tbody>
                                                <tr class="d-none table-row">
                                                    <td class="user_id">ID</td>
                                                    <td class="user_username">USERNAME</td>
                                                    <td class="user_role">ROLE</td>
                                                    <td class="fit">
                                                        <div class="f-flex">
                                                            <button class="btn btn-info mr-1 p-1 px-2 btn-update">
                                                                <i class="mdi mdi-pencil mdi-18px m-0"></i>
                                                            </button>
                                                            <button class="btn btn-danger ml-1 p-1 px-2 btn-delete">
                                                                <i class="mdi mdi-delete mdi-18px m-0"></i>
                                                            </button>
                                                        </div>
                                                    </td>
                                                </tr>
                                            </tbody>
                                        </table>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>

                <footer class="footer">
                    <div class="d-sm-flex justify-content-center justify-content-sm-between">
                        <span class="text-muted d-block text-center text-sm-left d-sm-inline-block">Copyright 2021 Florian Burgener</span>
                    </div>
                </footer>
            </div>
        </div>
    </div>

    <div class="modal fade" id="createModal" tabindex="-1">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">User Create</h5>
                    <button type="button" class="close" data-dismiss="modal">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <div class="alert alert-danger error-message" role="alert" style="display: none;">
                        EMPTY
                    </div>

                    <form class="forms-sample" id="createForm">
                        <div class="form-group">
                            <label for="usernameInput">Username *</label>
                            <input type="text" class="form-control" id="usernameInput" placeholder="Username">
                        </div>
                        <div class="form-group">
                            <label for="passwordInput">Password *</label>
                            <input type="password" class="form-control" id="passwordInput" placeholder="****************">
                        </div>
                        <div class="form-group">
                            <label for="roleSelect">Role *</label>
                            <select class="form-control" id="roleSelect"></select>
                        </div>
                    </form>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-danger px-3 py-2" id="closeCreateModal" data-dismiss="modal">Cancel</button>
                    <button type="button" class="btn btn-primary px-3 py-2" id="saveCreateModal">
                        Save
                    </button>
                </div>
            </div>
        </div>
    </div>

    <div class="modal fade" id="updateModal" tabindex="-1">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">User Update</h5>
                    <button type="button" class="close" data-dismiss="modal">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <div class="alert alert-danger error-message" role="alert" style="display: none;">
                        EMPTY
                    </div>

                    <form class="forms-sample" id="updateForm">
                        <div class="form-group">
                            <label for="usernameInput">Username *</label>
                            <input type="text" class="form-control" id="usernameInput" placeholder="Username">
                        </div>
                        <div class="form-group">
                            <label for="passwordInput">Password (leave blank if no change)</label>
                            <input type="password" class="form-control" id="passwordInput" placeholder="****************">
                        </div>
                        <div class="form-group">
                            <label for="roleSelect">Role *</label>
                            <select class="form-control" id="roleSelect"></select>
                        </div>
                    </form>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-danger px-3 py-2" data-dismiss="modal">Cancel</button>
                    <button type="button" class="btn btn-primary px-3 py-2" id="saveUpdateModal">
                        Save
                    </button>
                </div>
            </div>
        </div>
    </div>

    {% include 'scripts.html' %}
    <script>
        /*
         * Refreshes the data table.
         */
        function refreshTable() {
            // Sends the request to the API.
            axios.get('/api/v1/users').then(function (response) {
                $("#table tbody").find("tr:gt(0)").remove();

                var templateRow = $('#table tbody tr:first');
                var users = response.data;

                // For each user add a row in the data table.
                for (var i in users) {
                    var user = users[i];
                    var currentRow = templateRow.clone();
                    $(currentRow).removeClass('d-none');
                    $(currentRow).attr('data-id', user.id);
                    $(currentRow).find('.user_id').text(user.id);
                    $(currentRow).find('.user_username').text(user.username);
                    $(currentRow).find('.user_role').text(user.role.name);

                    if (user.id == 1) {
                        $(currentRow).find('.btn-update').prop('disabled', true);
                        $(currentRow).find('.btn-delete').prop('disabled', true);
                    }

                    $('#table tbody').append(currentRow);
                }
            });
        }

        refreshTable();

        /*
         * Initializes the list of roles.
         */
        function setRoles(roles, element) {
            $.each(roles, function () {
                element.append(`<option value="${this.id}">${this.name}</option>`)
            });
        }

        // Loads the list of roles.
        axios.get('/api/v1/roles').then(function (response) {
            var roles = response.data;
            setRoles(roles, $('#createForm #roleSelect'));
            setRoles(roles, $('#updateForm #roleSelect'));
        });

        /*
         * Empty the form.
         *
         * @param {Object} modal The modal.
         */
        function clearForm(modal) {
            modal.find('form').find("input").val("");
            var elements = modal.find('form').find("select");
            $.each(elements, function () {
                $(this).val($(this).find("option:first").val());
            });
        }

        $('#closeCreateModal, #closeUpdateModal').click(function () {
            // Empty the forms.
            clearForm($('#createModal'));
            clearForm($('#updateModal'));
            $('#createModal .error-message').hide();
            $('#updateModal .error-message').hide();
        });

        $('input').change(function () {
            // Hides error messages.
            $('#createModal .error-message').hide();
            $('#updateModal .error-message').hide();
        });
        $('input').keydown(function () {
            // Hides error messages.
            $('#createModal .error-message').hide();
            $('#updateModal .error-message').hide();
        });

        // CREATE

        /*
         * Create an user.
         */
        function createUser() {
            var config = {
                headers: {
                    "Content-Type": "application/json"
                },
            };

            // Sends the request to the API.
            axios.post('/api/v1/users', JSON.stringify({
                username: $('#createForm #usernameInput').val(),
                password: $('#createForm #passwordInput').val(),
                role_id: parseInt($('#createForm #roleSelect').val()),
            }), config).then(function (response) {
                $('#createModal').modal('hide');
                clearForm($('#createModal'));
                refreshTable();
            }).catch(function (error) {
                // Shows an error message.
                $('#createModal .error-message').show();
                $('#createModal .error-message').text(error.response.data.message);
            });
        }

        $('#saveCreateModal').click(function () {
            createUser();
        });

        // UPDATE

        /*
         * Update an user.
         */
        function updateUser() {
            var config = {
                headers: {
                    "Content-Type": "application/json"
                },
            };
            var data = {
                username: $('#updateForm #usernameInput').val(),
                role_id: parseInt($('#updateForm #roleSelect').val()),
            };

            if ($('#updateForm #passwordInput').val()) {
                data['password'] = $('#updateForm #passwordInput').val();
            }

            var id = parseInt($('#updateForm').attr('data-id'));

            // Sends the request to the API.
            axios.patch('/api/v1/users/' + id, JSON.stringify(data), config).then(function (response) {
                $('#updateModal').modal('hide');
                clearForm($('#updateModal'));
                refreshTable();
            }).catch(function (error) {
                // Shows an error message.
                $('#updateModal .error-message').show();
                $('#updateModal .error-message').text(error.response.data.message);
            });
        }

        $(document).on('click', '.table-row .btn-update', function () {
            // Opens the form to update an user.
            var id = parseInt($(this).closest('.table-row').attr('data-id'));

            // Sends the request to the API.
            axios.get('/api/v1/users/' + id).then(function (response) {
                var user = response.data.user;
                $('#updateForm').attr('data-id', user.id);
                $('#updateForm #usernameInput').val(user.username);
                $('#updateForm #roleSelect').val(user.role.id);

                $('#updateModal').modal('show');
            });
        });

        $('#saveUpdateModal').click(function () {
            updateUser();
        });

        // DELETE

        /*
         * Deletes an user.
         *
         * @param {integer} id The user identifier.
         */
        function deleteUser(id) {
            var config = {
                headers: {
                    "Content-Type": "application/json"
                },
            };

            // Sends the request to the API.
            axios.delete('/api/v1/users/' + id).then(function () {
                refreshTable();
            });
        }

        $(document).on('click', '.table-row .btn-delete', function () {
            // Deletes an user.
            var id = parseInt($(this).closest('.table-row').attr('data-id'));

            if (!confirm("Are you sure you want to delete user #" + id + "?")) {
                return;
            }

            deleteUser(id);
        });

    </script>
</body>

</html>
